using System;
using System.Configuration.Provider;

namespace Quotations
{
    public class QuotationsProviderCollection : ProviderCollection
    {
        public override void Add(ProviderBase provider)
        {
            if (provider == null)
                throw new ArgumentNullException("The provider parameter cannot be null.");

            if (!(provider is QuotationsProvider))
                throw new ArgumentException("The provider parameter must be of type QuotationsProvider.");

            base.Add(provider);
        }

        new public QuotationsProvider this[string name]
        {
            get { return (QuotationsProvider)base[name]; }
        }

        public void CopyTo(QuotationsProvider[] array, int index)
        {
            base.CopyTo(array, index);
        }
    }
}
