using System;
using System.Data;
using System.Configuration;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public class DeterminePortalApplication : IHttpModule
{
    //Urls are of the form http://some.server.name/portalid-a/default.aspx
    Regex r = new Regex("/portalid-(\\w+)", RegexOptions.IgnoreCase);

    public void Init(HttpApplication context)
    {
        context.BeginRequest += new EventHandler(this.HandleBeginRequest);
    }

    private void HandleBeginRequest(object source, EventArgs e)
    {
        HttpApplication a = (HttpApplication)source;
        HttpContext c = a.Context;

        string portalstring = String.Empty;
        string vpath = c.Request.Path;

        Match m = r.Match(vpath);
        if (m.Success)
        {
            portalstring = m.Value;
            string portalID = m.Groups[1].Captures[0].Value;

            //Only allow valid portal values
            if ((portalID == "a") || (portalID == "b") || (portalID == "c"))
            {
                int index = m.Index;
                int length = m.Length;

                //snip out the portal identifier string
                vpath = vpath.Replace(portalstring, null);

                //Store the portal information in the content
                c.Items["portalID"] = portalID;

                //Rewrite the path without the portal ID
                c.RewritePath(vpath, true);
            }
        }
    }

    public void Dispose() {}

    
}
