using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Login : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            //Fix up redirect URL if necessary
            string portalID = (string)Context.Items["portalID"];
            if (!String.IsNullOrEmpty(portalID))
                Login1.DestinationPageUrl = "portalid-" + portalID + "/" + Login1.DestinationPageUrl;
        }
    }
    protected void Login1_LoggedIn(object sender, EventArgs e)
    {
        //Get the portal id to store in the ticket
        string portalID = (string)Context.Items["portalID"];

        //Read out the cookie the Login control created
        HttpCookie formscookie = Response.Cookies[FormsAuthentication.FormsCookieName];
        FormsAuthenticationTicket original =
            FormsAuthentication.Decrypt(formscookie.Value);

        FormsAuthenticationTicket newTicket =
            new FormsAuthenticationTicket(original.Version,
                 original.Name,
                 original.IssueDate, original.Expiration,
                 original.IsPersistent, portalID);

        //And reset the ticket with the portal ID stored in UserData property
        formscookie.Value = FormsAuthentication.Encrypt(newTicket);
                 

    }
}
