using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class secured_Roles : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            RefreshAvailableRolesListBox();
            RefreshCurrentRolesRepeater();
        }
    }

    protected void btnCreateRole_Click(object sender, EventArgs e)
    {
        Roles.CreateRole(txtCreateRole.Text);
        RefreshAvailableRolesListBox();
    }

    protected void btnAddSelectedRole_Click(object sender, EventArgs e)
    {
        if (lbxAvailableRoles.SelectedIndex != -1)
        {
            if (!Roles.IsUserInRole(User.Identity.Name, lbxAvailableRoles.SelectedValue))
            {
                Roles.AddUserToRole(User.Identity.Name, lbxAvailableRoles.SelectedValue);
                RefreshCurrentRolesRepeater();
            }
        }
    }

    protected void btnDeleteUserFromRole_Click(object sender, EventArgs e)
    {
        if (lbxUserRoles.SelectedIndex != -1)
        {
            Roles.RemoveUserFromRole(User.Identity.Name, lbxUserRoles.SelectedValue);
            RefreshCurrentRolesRepeater();
        }
    }

    protected void btnDeleteRole_Click(object sender, EventArgs e)
    {
        if (lbxAvailableRoles.SelectedIndex != -1)
        {
            Roles.DeleteRole(lbxAvailableRoles.SelectedValue);
            RefreshAvailableRolesListBox();
            RefreshCurrentRolesRepeater();
        }
    }

    protected void RefreshAvailableRolesListBox()
    {
        lbxAvailableRoles.DataSource = Roles.GetAllRoles();
        lbxAvailableRoles.SelectedIndex = -1;
        lbxAvailableRoles.DataBind();
    }

    protected void RefreshCurrentRolesRepeater()
    {
        lbxUserRoles.DataSource = Roles.GetRolesForUser();
        lbxUserRoles.SelectedIndex = -1;
        lbxUserRoles.DataBind();
    }
}
