using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public class ExtendedMembershipUser : MembershipUser
{
    private string _firstName;
    private string _lastName;

	protected  ExtendedMembershipUser() {}

    public ExtendedMembershipUser(
            string providerName,
            string name,
            object providerUserKey,
            string email,
            string passwordQuestion,
            string comment,
            bool isApproved,
            bool isLockedOut,
            DateTime creationDate,
            DateTime lastLoginDate,
            DateTime lastActivityDate,
            DateTime lastPasswordChangedDate,
            DateTime lastLockoutDate,
            string   firstName,
            string   lastName) :
        base (providerName, name, providerUserKey, email, passwordQuestion, comment,
              isApproved, isLockedOut, creationDate, lastLoginDate, lastActivityDate,
              lastPasswordChangedDate, lastLockoutDate)
    {
        _firstName = firstName;
        _lastName = lastName;
    }

    //Copy constructor
    public ExtendedMembershipUser(MembershipUser mu)
        : base(mu.ProviderName, mu.UserName, mu.ProviderUserKey, mu.Email, mu.PasswordQuestion, mu.Comment,
             mu.IsApproved, mu.IsLockedOut, mu.CreationDate, mu.LastLoginDate, mu.LastActivityDate,
             mu.LastPasswordChangedDate, mu.LastLockoutDate)
    {
        _firstName = null;
        _lastName = null;
    }

    public virtual string FirstName
    {
        get { return _firstName; }
        set { _firstName = value; }
    }

    public virtual string LastName
    {
        get { return _lastName; }
        set { _lastName = value; }
    }
}
