using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Web;
using System.Web.Caching;
using System.Web.Configuration;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public class SqlCachingRoleProvider : SqlRoleProvider
{
	public SqlCachingRoleProvider() {}

    public override string[] GetRolesForUser(string username)
    {

        string cacheKey = username + ":" + this.ApplicationName;
        string[] retval = null;
        Cache c = HttpContext.Current.Cache;

        retval = (string[])c[cacheKey];
        if (retval == null)
        {
            retval = base.GetRolesForUser(username);

            using (SqlConnection conn =
                new SqlConnection(WebConfigurationManager.ConnectionStrings["LocalSqlServer"].ConnectionString))
            {
                SqlCommand cmd = new SqlCommand();
                cmd.CommandText = "select  uir.RoleId" +
                                  " from    dbo.aspnet_Users u, " +
                                  "         dbo.aspnet_Applications a, " +
                                  "         dbo.aspnet_UsersInRoles uir" +
                                  " where   a.LoweredApplicationName = LOWER('" + this.ApplicationName + "')" +
                                  " and     u.LoweredUserName = LOWER('" + username + "')" +
                                  " and     u.ApplicationId   = a.ApplicationId" +
                                  " and     u.UserId          = uir.UserId";
                cmd.Connection = conn;
                cmd.CommandType = CommandType.Text;

                SqlCacheDependency sc = new SqlCacheDependency(cmd);

                conn.Open();
                object result = cmd.ExecuteScalar();
                conn.Close();

                c.Insert(cacheKey, retval, sc, Cache.NoAbsoluteExpiration, Cache.NoSlidingExpiration);
            }
        }

        return retval;
    }

}
