using System;
using System.Web;
using System.Web.Security;
using System.Collections;
using System.Web.Services;
using System.Web.Services.Protocols;


/// <summary>
/// Summary description for LoginService
/// </summary>
[WebService(Namespace = "http://microsoft.com/aspnet/prototype/formsauthentication")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class LoginService : System.Web.Services.WebService {

    public LoginService() { }

    [WebMethod]
    public bool ValidateUserAndIssueFormsAuthCookie(string username, string password)
    {
        MembershipProvider prov;
        //Add logic or raise event to determine the correct provider name at this point
        prov = Membership.Providers[Membership.Provider.Name];

        bool retval = prov.ValidateUser(username, password);

        if (retval == true)
        {
            FormsAuthentication.SetAuthCookie(username, false);

            //Stuff the provider into the ticket for future reference
            HttpCookie c = HttpContext.Current.Response.Cookies[FormsAuthentication.FormsCookieName];
            string rawTicket = c.Value;
            FormsAuthenticationTicket ft = FormsAuthentication.Decrypt(rawTicket);
            FormsAuthenticationTicket ft2 =
                new FormsAuthenticationTicket(
                    ft.Version,
                    ft.Name,
                    ft.IssueDate,
                    ft.Expiration,
                    ft.IsPersistent,
                    prov.Name);
            rawTicket = FormsAuthentication.Encrypt(ft2);
            c.Value = rawTicket;
        }

        return retval;
    }

    [WebMethod]
    public string ValidateUserAndReturnFormsAuthTicket(string username, string password)
    {
        MembershipProvider prov;
        //Add logic or raise event to determine the correct provider name at this point
        prov = Membership.Providers[Membership.Provider.Name];

        bool retval = prov.ValidateUser(username, password);

        string rawTicket = String.Empty;
        if (retval == true)
        {
            FormsAuthentication.SetAuthCookie(username, false);
            HttpCookie c = HttpContext.Current.Response.Cookies[FormsAuthentication.FormsCookieName];
            rawTicket = c.Value;
            HttpContext.Current.Response.Cookies.Remove(FormsAuthentication.FormsCookieName);

            //Stuff the provider into the ticket
            FormsAuthenticationTicket ft = FormsAuthentication.Decrypt(rawTicket);
            FormsAuthenticationTicket ft2 =
                new FormsAuthenticationTicket(
                    ft.Version,
                    ft.Name,
                    ft.IssueDate,
                    ft.Expiration,
                    ft.IsPersistent,
                    prov.Name);
            rawTicket = FormsAuthentication.Encrypt(ft2);
        }

        return rawTicket;
    }
    
}

